/**
 * \file gen_array3.hpp
 *
 * Generikus tmb interfsz
 *   Jporta "NHF 3. - skeleton" feladatnak bemutatshoz.
 *
 * Feladat:
 *   Fix mret Generikus tmb megvalstsa.
 */
/// Tmb sablon
/// @param T - adattpus
/// @param s - mret, defalult: 50
/// @param E - hibaosztly (indexelsi hiba esetn hvdik) defalul: std::range_error
template <class T, int s = 50, class E = std::range_error>
class Array {               // osztlysablon
    // private adattagok, tagfggvnyek az interfeszen nem ltszanak,
    // ezrt ezeket a tervezs ezen fzisban nem adjuk meg.
public:
    /// Indexels.
    /// @param i - index
    /// @return - referencia az adott index elemre
    /// @return - hibs indexrtk esetn E() kivtelt dob
    T& operator[](int i);

    /// Indexels konstans fggvnye.
    /// @param i - index
    /// @return - referencia az adott index elemre
    /// @return - hibs indexrtk esetn E() kivtelt dob
    const T& operator[](int i) const;
};
